// This file is part of Lx.
//
// Copyright 2003, 2004, Norman Gray (norman@astro.gla.ac.uk).
// Released under the terms of the GNU General Public Licence:
// see the file LICENCE for details.


package uk.me.nxg.lx;

/**
 * An exception for the Lx package.
 *
 * @author Norman Gray
 * @version 0.5.3, 2012 August 5
 */
public class LxException extends java.lang.Exception {

    private String msg;
    
    private LxException() {
    }
    
    public LxException(String message) {
	this(message, null, null);
    }

    public LxException(Throwable cause) {
        this(null, cause, null);
    }

    public LxException(String message, Throwable cause) {
        this(message, cause, null);
    }

    public LxException(String message, org.xml.sax.Locator loc) {
        this(message, null, loc);
    }

    public LxException(String message,
                       Throwable cause,
                       org.xml.sax.Locator loc) {
        super(cause);

        StringBuffer sb = new StringBuffer(message);
        if (loc != null) {
            sb.append(" [").append(loc.getSystemId());
            if (loc.getLineNumber() >= 0) {
                sb.append(':').append(loc.getLineNumber());
                if (loc.getColumnNumber() >= 0)
                    sb.append(':').append(loc.getColumnNumber());
            }
        }
        
        msg = sb.toString();
    }

    public String getMessage() {
        return msg;
    }
}

    
